using System;
using System.EnterpriseServices;

namespace ObjectPoolingCompLib
{
	[ObjectPooling(true, 5, 10)]
	public class PooledClass : ServicedComponent
	{
		private int activationCount = 0;
		private int deactivationCount = 0;
		private readonly string objectID = Guid.NewGuid().ToString();
		// Not a good idea. Just for demo purpose!

		public PooledClass()
		{
		}
		
		protected override void Activate()
		{
			base.Activate ();
			activationCount++;
		}

		protected override void Deactivate()
		{
			base.Deactivate ();
			deactivationCount++;
		}

		protected override bool CanBePooled()
		{
			return true;
		}

		private string getAppDomainThreadInfo()
		{
			return "AppDomain: " + AppDomain.CurrentDomain.FriendlyName + 
				" Thread ID: " + AppDomain.GetCurrentThreadId();
		}

		public string getInfo()
		{
			return "(Object " + objectID + "-" + getAppDomainThreadInfo() + ") " +
				"Activation: " + activationCount +
				" Deactivation: " + deactivationCount;
		}
	}
}
